//----------------------------------------------------------------------------
// 
//	file: coord.h
// 
//	function:  define a simple coordinate type
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Fri Aug  7 04:15:58 CDT 1998
// 
//	$Revision: 1.2 $ $Date: 1998/10/05 19:48:46 $
//	$Log: coord.h,v $
//	Revision 1.2  1998/10/05 19:48:46  yschoe
//	added matrix_coord for use with get_aff/inh/exc_matrix in netlayer.cc
//
//	Revision 1.1  1998/08/11 16:54:44  yschoe
//	simple coordinate struct
//
//
//----------------------------------------------------------------------------
#ifndef __COORD_H
#define __COORD_H

typedef struct {
	REAL x;
	REAL y;
} coord;	

typedef struct {
  REAL **matrix;        
  int  cx;     	// center x          
  int  cy;      // center y
  int  lowx;
  int  highx;
  int  lowy;
  int  highy; 
  int  cols;
  int  rows;
} matrix_coord;

#endif
