function [evec,eval] = empcaol_orth(C)
%[evec,eval] = empcaol_orth(Cfinal)
%
% finds ordered orthogonal basis for subspace identified in Cfinal
%
% online method
% uses nextpoint(1) to initialize data generator 
% uses nextpoint(0) to provide successive data vectors
% NB: nextpoint should return data with the mean already subtracted out


[p,k] = size(C);
W = zeros(k,k);

C = orth(C);
  
nextpoint(1);
[yi,status] = nextpoint(0);
while(status>0)
%    fprintf(1,'Now processing datapoint %d\r',status);
  nf = status;
  xi = C'*yi;
  W = W+xi*xi';
  [yi,status] = nextpoint(0);
end

[cvv,cdd] = eig(W/nf);
[zz,ii] = sort(diag(cdd));
ii = flipud(ii);
xevec = cvv(:,ii);
cdd = diag(cdd);
eval = cdd(ii);

evec = C*xevec;
  
  
