## Copyright (C) 2000 uschoe
##
## This file is part of Octave.
##
## Octave is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2, or (at your option)
## any later version.
##
## Octave is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Octave; see the file COPYING.  If not, write to the Free
## Software Foundation, 59 Temple Place - Suite 330, Boston, MA
## 02111-1307, USA.

## usage: illusory (N, M, s, theta)
##
## Returns a NxM matrix with illusory contour located at center
## with line spacing s and orientation of contour theta angle.
## 	s : should be an even number.
##

## Author: Yoonsuck Choe <yschoe@cs.utexas.edu>

function g = illusory (N, M, spacing, theta)

  radian = theta * pi / 180.0;

  g = zeros(M,N);

  for i=1:M 
	if (rem(i,spacing)==0) 
		g(i,1:N/2)=zeros(1,N/2).+2;
	endif
	if (rem(i+spacing/2,spacing)==0) 
		g(i,N/2+1:N)=zeros(1,N/2).+2;
	endif
  endfor

  g = g .- 1;

endfunction
