//----------------------------------------------------------------------------
// 
//	file: matrix_window_test.cc
// 
//	function: test matrix_window class 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Mon Jul  6 17:29:00 CDT 1998
// 
//	$Revision: 1.3 $ $Date: 2000/01/30 14:55:55 $
//	$Log: matrix_window_test.cc,v $
//	Revision 1.3  2000/01/30 14:55:55  yschoe
//	*** empty log message ***
//
//	Revision 1.2  1999/02/09 07:56:44  yschoe
//	*** empty log message ***
//
//	Revision 1.1  1998/10/16 10:35:21  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
#include <window.h>
#include <math.h>
#include <iostream.h>
#include <stream.h>
#include <nnview/real.h>
#include <nnview/matrix_window.h>
#include <nnview/plot_window.h>
#include <nnview/tool_window.h>
#include <nnview/util.h>

class mymain_window : public main_window {

public: 
  mymain_window(char *name, int x, int y) : main_window(name,x,y) {
     selection_mask |= ButtonPressMask | ButtonReleaseMask | PointerMotionMask;
  }
  ~mymain_window(){};
/*
  virtual void BPress_CB(XButtonEvent ev) {
	cout << "mymain_window : clicked at " << ev.x << "," << ev.y << endl;
  }
*/
};

// Windows
matrix_window 	*matwin;
mymain_window 	*mw;
plot_window     *plotwin2;
button 		*dump;
button		*zoomplus;
button		*zoomminus;

int	cols;

// scroll bar
scrollbar *scbr;
void set_scale() { 
  matwin->set_scale(scbr->value);
}

// dump callback
void dump_callback() {
  static int i;
  static int toggle;
  REAL	v;

  if (plotwin2 == (plot_window *)NULL) {
	cout << "dump_callback(): plot window is gone.\n";
	return;
  }
  
  //text_popup *tp= new text_popup("Matrix Dump",300,300,matwin->disp_values());
  for (int j=0; j<cols; ++j) {
    v = (REAL)i;
    plotwin2->push_data(
	//(REAL)(sin((REAL)10*i)*sin((REAL)100*i) + (REAL)1.0)
 	(REAL)(v-1)*(v-20)*(v-30)*(v-40) +50
	//(REAL)(v*v*sin(200*v))
	);
	i++;
  }
}

/* This part caused a seg fault at the end of the program.. wonder why..
void zoompluscallback() {
	plotwin2->set_zoom(plotwin2->get_zoom()*2.0);
}

void zoomminuscallback() {
	plotwin2->set_zoom(plotwin2->get_zoom()/2.0);
}
*/

void main (int argc, char *argv[])
{
  
  // Init array
  // REAL	**array = new REAL* [20];
  //for (int i=0; i<30; ++i)
  //	array[i] = new REAL [30];
  
  if (argc==2) { cols = atoi(argv[1]); } else { cols = 50; }
  cout << "cols = " << cols << "\n";
  
  REAL	*array = new REAL [600];
  REAL  *array2 = new REAL [300];  

  // Set up windows
  mw = new mymain_window(argv[0],300,320);
  matwin = new matrix_window(*mw,300,300,0,0,0,50,HSV_MULT,20,30,array);

  // Fill in array
  //for (int j=0; j<30; ++j)
  //	for (int i=0; i<20; ++i) 
  //		array[i][j] = (REAL)((i+j*20)/600.0);
  for (int i=0; i<600; ++i) 
	array[i] = (REAL)(i/600.0);
  for (int i=0; i<300; ++i) {
	REAL v = (REAL)i;	
 	//array2[i] = 5*sin(20.0*v)+(v-50)*(v-50);
	// array2[i] = (v-10)*(v-20)*(v-30)*(v-40)*(v-50)*(v-60)*(v-90)*(v-100);
	//array2[i] = sin(200.0*(REAL)i) + 1.0;
	array2[i] = -((REAL)i-30)*((REAL)i-90)*((REAL)i-60);
  }

  // quit button
  new quit_button(*mw,mw->width/4,20,mw->width*3/4,mw->height-20); 

  // sliding scale
  scbr = new scrollbar(*mw,&set_scale,mw->width/2,20,0,mw->height-20,
		0.1,10.0,0.1,"scale=%.1lf");  
 
  // Dump button
  dump = new callback_button(*mw,"Matrix Dump",dump_callback,
		mw->width/4,20,mw->width/2,mw->height-20);
/*
  zoomplus = new callback_button(*mw,"Zoom+",zoompluscallback,
		mw->width/4,20,0,mw->height-40);
  zoomminus = new callback_button(*mw,"Zoom-",zoomminuscallback,
		mw->width/4,20,mw->width/4,mw->height-40);
*/

  //text_popup *tp= new text_popup("Matrix Dump",300,300,matwin->disp_values());
  // popup_button *pb = new popup_button(*mw,tp,"Dump",mw->width/4,20,
  //		mw->width/2,mw->height-20);

  // batch input plot window demo
  tool_window *tw = new tool_window("Tool",300,300,0,0);
  plot_window *plotwin = new plot_window(*tw,300,300,0,0,0,10,COLOR,
	300,array2);
  tw->toggle(); // Activate the window.

  // serial input plot window demo
  tool_window *tw2 = new tool_window("Tool2",600,150,0,0);
  plotwin2 = new plot_window(*tw2,600,150,0,0,0,10,COLOR,
		cols,cols);
  tw2->toggle(); // Activate the window.

  // Start main_loop
  mw->main_loop();

  delete [] array;
  delete [] array2;
}
  

